<?xml version="1.0"?>
<!-- 
(c)2005 David Sporn

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public
License version 2.1 as published by the Free Software Foundation.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text"/>

<!-- ===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-=== -->
<!-- Root node conversion -->
<xsl:template match="Action"><![CDATA[<?php]]>
<![CDATA[/****** GENERATED CODE - DO NOT EDIT ******/]]>
<![CDATA[/* ]]><xsl:value-of select="description"/><![CDATA[ */]]>
	<xsl:apply-templates mode="doImport" select="imports/*|forms/*|action"/>

<![CDATA[/****** Init form beans ******/]]>
	<xsl:apply-templates mode="initFormData" select="forms/*"/>

<![CDATA[/****** Init forward mapping ******/]]>
	<xsl:apply-templates mode="initForward" select="forwards/*"/>

<![CDATA[/****** Call action ******/]]>
	<xsl:apply-templates mode="process" select="action"/>

<![CDATA[/****** Execute forward ******/]]>
<![CDATA[if (@isset($forward))]]>
<![CDATA[{]]>
	<![CDATA[if ($forward['redirect'])]]>
	<![CDATA[{]]>
		<![CDATA[header('Location: '.$forward['path']) ;]]>
	<![CDATA[}]]>
	<![CDATA[else]]>
	<![CDATA[{]]>
		<![CDATA[include $forward['path'] ;]]>
	<![CDATA[}]]>
<![CDATA[}]]>
<![CDATA[else]]>
<![CDATA[{]]>
	<![CDATA[echo 'Action did not return anything' ;]]>
<![CDATA[}]]>

<![CDATA[?>]]>
</xsl:template>

<!-- ===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-=== -->
<!-- imports generation -->
<xsl:template match="import|action" mode="doImport">
<![CDATA[require_once ']]><xsl:value-of select="@path"/><![CDATA[' ;]]>
</xsl:template>

<xsl:template match="form" mode="doImport">
	<xsl:variable name="requestInclude" select="concat('classes/', @request, '.php')" />
	<xsl:variable name="beanInclude" select="concat('classes/', @request, 'Bean.php')" />
<![CDATA[require_once ']]><xsl:value-of select="$requestInclude"/><![CDATA[' ;]]>
<![CDATA[require_once ']]><xsl:value-of select="$beanInclude"/><![CDATA[' ;]]>
</xsl:template>

<!-- ===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-=== -->
<!-- retrieve forms data -->
<xsl:template match="form" mode="initFormData">
	<xsl:variable name="requestProcessor" select="@request" />
	<xsl:variable name="bean" select="concat(@request, 'Bean')" />
<![CDATA[$processor = new ]]><xsl:value-of select="$requestProcessor"/><![CDATA[(']]><xsl:value-of select="@namespace"/><![CDATA[') ;]]>
<![CDATA[$bean = new ]]><xsl:value-of select="$bean"/><![CDATA[() ;]]>
<![CDATA[$bean->copyFrom($processor) ;]]>
<![CDATA[$forms[']]><xsl:value-of select="@name"/><![CDATA['] = $bean ;]]>
</xsl:template>

<!-- ===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-=== -->
<!-- init forwards data -->
<xsl:template match="forward" mode="initForward">
	<xsl:variable name="isRedirect">
		<xsl:choose>
			<xsl:when test="@redirect='false'">false</xsl:when>
			<xsl:otherwise>true</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
<![CDATA[$forward = array() ;]]>
<![CDATA[$forward['path'] = ']]><xsl:value-of select="@path"/><![CDATA[' ;]]>
<![CDATA[$forward['redirect'] = ]]><xsl:value-of select="$isRedirect"/><![CDATA[ ;]]>
<![CDATA[$forwardMapping[']]><xsl:value-of select="@name"/><![CDATA['] = $forward ;]]>
</xsl:template>

<!-- ===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-===-=== -->
<!-- init forwards data -->
<xsl:template match="action" mode="process">
	<xsl:variable name="isRedirect">
		<xsl:choose>
			<xsl:when test="@redirect='false'">false</xsl:when>
			<xsl:otherwise>true</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
<![CDATA[$action = new ]]><xsl:value-of select="@classname"/><![CDATA[() ;]]>
<![CDATA[$forward = $action->perform($forms, $forwardMapping) ;]]>
</xsl:template>

</xsl:stylesheet>